AT(1)

NAME
at, batch, atq, atrm - queue, examine or delete jobs for later execution

SYNOPSIS
at [-V] [-q queue] [-f file] [-mldbv] time

atq [-V] [-q queue] [-v]

atrm [-V] job [job ...]

batch [-V] [-q queue] [-f file] [-mv] [time]

DESCRIPTION
at, AT&T UNIX and batch read commands from standard input or a specified file which are to be executed at a later time, using sh(1).

at  executes commands at a specified time;

atq lists the user's pending jobs, unless the user is the superuser; in that case, everybody's jobs are listed;

atrm
    deletes jobs;

batch
    executes commands when system load levels permit; in other words, when the load average drops below _LOADAVG_MX, or the value specified in the invocation of atrun.

at, AT&T UNIX allows some moderately complex time specifications. It accepts times of the form HHMM or HH:MM to run a job at a specific time of day. (If that time is already past, the next day is assumed.) You may also specify midnight, noon, or teatime (4pm) and you can have a time-of-day suffixed with AM or PM for running in the morning or the evening. You can also say what day the job will be run, by giving a date in the form month-name day with an optional year, or giving a date of the form MMDDYY or MM/DD/YY or DD.MM.YY. You can also give times like [now] + count time-units, where the time-units can be minutes, hours, days, or weeks and you can tell at to run the job today by suffixing the time with today and to run the job tomorrow by suffixing the time with tomorrow.

For example, to run a job at 4pm three days from now, you would do at 4pm + 3 days, to run a job at 10:00am on July 31, you would do at 10am Jul 31 and to run a job at 1am tomorrow, you would do at 1am tomorrow.

For both at and batch, commands are read from standard input or the file specified with the -f option and executed. The working directory, the environment (except for the variables TERM, TERMCAP, DISPLAY and _) and the umask are retained from the time of invocation. An at or batch command invoked from a su(1) shell will retain the current userid. The user will be mailed standard error and standard output from his commands, if any. Mail will be sent using the command sendmail(8). If at is executed from a su(1) shell, the owner of the login shell will receive the mail.

The superuser may use these commands in any case. For other users, permission to use at is determined by the files _PERM_PATH/at.allow and _PERM_PATH/at.deny.

If the file _PERM_PATH/at.allow exists, only usernames mentioned in it are allowed to use at.

If _PERM_PATH/at.allow does not exist, _PERM_PATH/at.deny is checked, every username not mentioned in it is then allowed to use at.

If neither exists, only the superuser is allowed use of at.

An empty _PERM_PATH/at.deny means that every user is allowed use these commands, this is the default configuration.

OPTIONS

-V  prints the version number to standard error.

-q queue
    uses the specified queue. A queue designation consists of a single letter; valid queue designations range from a to z. and A to Z. The _DEFAULT_AT_QUEUE queue is the default for at and the _DEFAULT_BATCH_QUEUE queue for batch. Queues with higher letters run with increased niceness. If a job is submitted to a queue designated with an uppercase letter, it is treated as if it had been submitted to batch at that time. If atq is given a specific queue, it will only show jobs pending in that queue.

-m  Send mail to the user when the job has completed even if there was no output.

-f file
    Reads the job from file rather than standard input.

-l  Is an alias for atq.

-d  Is an alias for atrm.

-b  Is an alias for batch.

-v  For atq, shows completed but not yet deleted jobs in the queue; otherwise shows the time the job will be executed.

FILES
_ATJOB_DIR
    Directory containing job files
_ATSPOOL_DIR
    Directory containing output spool files
/var/run/utmp
    Login records
_PERM_PATH/at.allow
    Allow permission control
_PERM_PATH/at.deny
    Deny permission control
_ATJOB_DIR/_LOCKFILE
    Job-creation lock file.

SEE ALSO
cron(8), nice(1), umask(2), sh(1), sendmail(8), atrun(8).

BUGS

If the file /var/run/utmp is not available or corrupted, or if the user is not logged on at the time at is invoked, the mail is sent to the userid found in the environment variable LOGNAME. If that is undefined or empty, the current userid is assumed.

at, AT&T UNIX and batch as presently implemented are not suitable when users are competing for resources. If this is the case for your site, you might want to consider another batch system, such as nqs.

AUTHOR
At was mostly written by Thomas Koenig, ig25@rz.uni-karlsruhe.de. The time parsing routines are by David Parsons, orc@pell.chi.il.us.